# List Employees

> Source: https://truto.one/docs/api-reference/unified-hris-api/employees/list/

`GET /unified/hris/employees`

Resource: **Employees** · API: **Unified HRIS API**

## Supported integrations

AlexisHR, BambooHR, Breathe, Charlie, ClayHR, darwinbox, Factorial, Google (partial), Google Workspace (partial), greytHR (partial), Gusto (partial), Hailey HR, HeavenHR (partial), HiBob (partial), HR Cloud, HROne, HR Partner (partial), Humaans, IntelliHR, JumpCloud, Keka, Kenjo (partial), Lucca, Microsoft 365, Microsoft Dynamics 365 Business Central, MYNDHRX, Namely, Oracle Netsuite, Officient (partial), Okta (partial), Oracle Fusion Cloud HCM, PeopleForce, PeopleHR, Personio, PrimePay HR (partial), Repute (partial), Rippling, ServiceNow, Square (partial), Workable (partial), Zoho People (partial), Zwayam (partial)

## Query parameters

- **`integrated_account_id`** _(string, required)_
  The ID of the integrated account to use for the request.
- **`truto_response_format`** _(string)_
  The format of the response. - `unified` returns the response with unified mappings applied. - `raw` returns the unprocessed, raw response from the remote API. - `normalized` applies the unified mappings and returns the data in a normalized format. - `stream` returns the response as a stream, which is ideal for transmitting large datasets, files, or binary data. Using streaming mode helps to efficiently handle large payloads or real-time data flows without requiring the entire data to be buffered in memory. Defaults to `unified`.
  Allowed: `unified`, `raw`, `normalized`, `stream`
- **`truto_key_by`** _(string)_
  By default the `result` attribute is an array of objects. This parameter allows you to specify a field in each `result` objects to use as key, which transforms the `result` array into an object with the array items keyed by the field. This is useful for when you want to use the result as a lookup table.
- **`truto_ignore_limit`** _(boolean)_
  Ignores the `limit` query parameter.
- **`truto_ignore_remote_data`** _(boolean)_
  Excludes the `remote_data` attribute from the response.
- **`truto_exclude_fields`** _(array<string>)_
  Array of fields to exclude from the response.
- **`remote_query`** _(object)_
  Query parameters to pass to the underlying API without any transformations. Refer [this guide](https://truto.one/docs/api-reference/overview/querying#remote-query-parameters) to see how to structure the query parameters.
- **`employment_status`** _(string)_
  This represents the employment status. If no clear mapping is available, then the raw value is returned.
  Allowed: `active`, `all`, `excluded`, `inactive`, `newHire`, `on_leave`, `pending`, `retired`, `terminated`
- **`groups`** _(array<object>)_
  This represents the groups
- **`manager`** _(object)_
  Represents the manager of the employee. Is also an employee.
- **`employee_number`** _(string)_
  This represents the employee number
- **`first_name`** _(string)_
  This represents the first name of the employee
- **`last_name`** _(string)_
  This represents the last name of the employee
- **`emails`** _(array<object>)_
  When updated_at is provided, the emails query parameter is ignored.
- **`phones`** _(array<object>)_
  The phones of the user
- **`created_at`** _(string)_
  This represents the date when the Employee was created
- **`updated_at`** _(string)_
  This represents the date when the Employee was updated
- **`start_date`** _(string)_
  This represents the start date
- **`termination_date`** _(string)_
  This represents the termination date
- **`name`** _(string)_
  This represents the name of the employee
- **`company`** _(object)_
  This represents the company
- **`work_location`** _(object)_
  This represents the work location
- **`gender`** _(string)_
  This represents gender
- **`tags`** _(array<object>)_
  The employee's tags
- **`product`** _(string)_
  Select the product for which you want to retrieve the employees.
  Allowed: `azure_active_directory`
- **`job_title`** _(string)_
  Job title of the employee
- **`middle_name`** _(string)_
  This represents the middle name of the employee
- **`sort_by`** _(object)_

## Response body

- **`result`** _(array<object>)_
  List of Employees
  - **`id`** _(string, required)_
    The unique identifier for employees
  - **`employee_number`** _(string)_
    This represents the employee number
  - **`company`** _(object)_
    This represents the company
    - **`id`** _(string)_
      The unique identifier for companies
  - **`first_name`** _(string)_
    This represents the first name of the employee
  - **`middle_name`** _(string)_
    This represents the middle name of the employee
  - **`last_name`** _(string)_
    This represents the last name of the employee
  - **`name`** _(string)_
    This represents the name of the employee
  - **`username`** _(string)_
    This represents the username
  - **`job_title`** _(string)_
    Job title of the employee
  - **`groups`** _(array<object>)_
    This represents the groups
    - **`id`** _(string)_
      The unique identifier for groups
    - **`name`** _(string)_
      Group's name
    - **`type`** _(string)_
      Type of the group. Some underlying providers use this to differentiate between in-built and user created groups.
  - **`emails`** _(array<object>)_
    The emails of the user
    - **`email`** _(string)_
      The email address
    - **`type`** _(string)_
      The type of email address
    - **`is_primary`** _(boolean)_
      Whether the email address is primary
  - **`phones`** _(array<object>)_
    The phones of the user
    - **`number`** _(string)_
      The phone number
    - **`extension`** _(string)_
      The extension of the phone number
    - **`type`** _(string)_
      The type of phone number
  - **`employments`** _(array<object>)_
    Represents a role or employment of the employee in the company
    - **`id`** _(string, required)_
      The unique identifier for employments
    - **`employee`** _(object)_
      Employee associated with this employment
      - **`id`** _(string)_
        The unique identifier for employees
    - **`job_title`** _(string)_
      Job title of the employee
    - **`pay_rate`** _(number)_
      This represents the pay rate
    - **`pay_period`** _(string)_
      This represents the pay period
    - **`pay_frequency`** _(string)_
      This represents the pay frequency
    - **`pay_currency`** _(string)_
      This represents the pay currency
    - **`pay_group`** _(string)_
      This represents the pay group
    - **`flsa_status`** _(string)_
      This represents the flsa status
    - **`effective_date`** _(string)_
      Represents the effective date of the employment
    - **`end_date`** _(string)_
      Represents the end date of the employment
    - **`employment_type`** _(string)_
      This represents the employment type
      Allowed: `full_time`, `part_time`, `contract`, `internship`, `temporary`, `trainee`, `volunteer`, `per_diem`
    - **`end_reason`** _(string)_
      Represents why the employment ended
    - **`created_at`** _(string)_
      This represents the date when the employments was created
    - **`updated_at`** _(string)_
      This represents the date when the employments was updated
  - **`home_location`** _(array<object>)_
    This represents the home location
    - **`id`** _(string)_
      The unique identifier for locations
    - **`name`** _(string)_
      This represents the name of the location
    - **`street_1`** _(string)_
      The first line of home address
    - **`street_2`** _(string)_
      The second line of home address
    - **`city`** _(string)_
      The city of the home address
    - **`state`** _(string)_
      The state/province of the home address
    - **`postal_code`** _(string)_
      The postal code of the home address
    - **`country`** _(string)_
      The country of the home address
  - **`work_location`** _(object)_
    This represents the work location
    - **`id`** _(string)_
      The unique identifier for locations
    - **`name`** _(string)_
      This represents the name of the location
    - **`street_1`** _(string)_
      The first line of work address
    - **`street_2`** _(string)_
      The second line of work address
    - **`city`** _(string)_
      The city of the work address
    - **`state`** _(string)_
      The state/province of the work address
    - **`postal_code`** _(string)_
      The postal code of the work address
    - **`country`** _(string)_
      The country of the work address
  - **`manager`** _(object)_
    Represents the manager of the employee. Is also an employee.
    - **`id`** _(string)_
      The unique identifier for employees
    - **`name`** _(string)_
      This represents the name of the employee
  - **`pay_group`** _(object)_
    This represents the pay group
    - **`id`** _(string)_
      The unique identifier for pay groups
  - **`ssn`** _(string)_
    This represents the ssn
  - **`gender`** _(string)_
    This represents gender
  - **`ethnicity`** _(string)_
    This represent ethnicity
  - **`marital_status`** _(string)_
    This represents marital status
  - **`date_of_birth`** _(string)_
    This represents date of birth
  - **`start_date`** _(string)_
    This represents the start date
  - **`employment_status`** _(string)_
    This represents the employment status. If no clear mapping is available, then the raw value is returned.
    Allowed: `active`, `inactive`, `pending`
  - **`termination_date`** _(string)_
    This represents the termination date
  - **`termination_type`** _(string)_
    Represents the type of termination. If no clear mapping exists, then raw value is returned.
    Allowed: `voluntary`, `dismissed`, `redundancy`, `end_of_contract`, `retirement`, `mutual`
  - **`termination_reason`** _(string)_
    Represents the reason for termination
  - **`avatar`** _(string)_
    This represents the avatar
  - **`tags`** _(array<object>)_
    The employee's tags
    - **`id`** _(string)_
      The tag's unique identifier
    - **`name`** _(string)_
      The tag's name
  - **`created_at`** _(string)_
    This represents the date when the Employee was created
  - **`updated_at`** _(string)_
    This represents the date when the Employee was updated
  - **`etag`** _(string)_
    The unique identifier for the specific version of the resource.
  - **`remote_data`** _(object)_
    Raw data returned from the remote API call.
- **`next_cursor`** _(string)_
  The cursor to use for the next page of results. Pass this value as `next_cursor` in the query parameter in the next request to get the next page of results.

## Code examples

### curl

```bash
curl -X GET 'https://api.truto.one/unified/hris/employees?integrated_account_id=<integrated_account_id>' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json'
```

### JavaScript

```javascript
const integratedAccountId = '<integrated_account_id>';

const response = await fetch(`https://api.truto.one/unified/hris/employees?integrated_account_id=${integratedAccountId}`, {
  method: 'GET',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/unified/hris/employees"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
    "integrated_account_id": "<integrated_account_id>"
}

response = requests.get(url, headers=headers, params=params)
print(response.json())
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

const result = await truto.unifiedApi.list(
  'hris',
  'employees',
  { integrated_account_id: '<integrated_account_id>' }
);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    async for item in truto_api.unified_api.list(
        "hris",
        "employees",
        {"integrated_account_id": "<integrated_account_id>"}
    ):
        print(item)

asyncio.run(main())
```
